import re, sys

stamped = stamped = re.compile(r'^(\d\d):(\d\d):(\d\d)(?= )', re.M)

def seconds(h,m,s):
    return s +60* (m +60* h)

def stamp(seconds):
    r = []
    for n in 2,1,0:
        f = 60**n
        x = seconds / f
        r.append(x)
        seconds -= x * f
    return r

    h = seconds / (60*60)
    seconds -= h * 60 * 60
    return seconds / (60*60), (seconds % (60*60))

def offset(i0, i1):
    h0,m0,s0 = [int(x) for x in stamped.search(i0).groups()]
    h1,m1,s1 = [int(x) for x in stamped.search(i1).groups()]
    
    diff = seconds(h1,m1,s1) - seconds(h0,m0,s0)
    s = stamped.split(i0)[1:]
    o = []
    while s:
        hh,mm,ss,text = s[:4]
        s = s[4:]
        o.append('%02d:%02d:%02d%s' % tuple(
                stamp( seconds(int(hh),int(mm),int(ss)) + diff) + [ text ] ))
    return ''.join(o)

def round2(x):
    return ((x + 1)/2) * 2

def round(i0):
    s = stamped.split(i0)[1:]
    o = []
    while s:
        hh,mm,ss,text = s[:4]
        s = s[4:]
        o.append('%02d:%02d:%02d%s' % tuple(
                stamp( round2(seconds(int(hh),int(mm),int(ss)))) + [ text ] ))
    return ''.join(o)

if __name__ == '__main__':
    if len(sys.argv) == 1:
        s0 = r'''14:36:14 a
- -
14:39:16 b
foo
bar
15:00:13 c
% %
'''
        s1 = r'''16:02:01 d
16:33:22 e
17:12:00 f
'''
        print round(s0)
        print offset(s0,s1)

    elif len(sys.argv) == 2:
        print round(open(sys.argv[1]).read())
    else:
        print offset(open(sys.argv[1]).read(), open(sys.argv[2]).read())

# python shiftime.py tdebug.1.mac tdebug.linux > tdebug.1.mac.shifted && python shiftime.py tdebug.1.mac.shifted > tdebug.1.mac.shifted.rounded && python shiftime.py tdebug.linux > tdebug.linux.rounded
